
use clap::Parser;

use sudoku::sudoku::*;
use sudoku::ksudoku::load_ksudoku;



// Command line arguments - via clap

#[derive(Parser)]
struct Cli {
    /// The path to the file to read
    filename: std::path::PathBuf,
}

fn main() {
    let args = Cli::parse();

    let puzzle = load_ksudoku(args.filename).unwrap();

    /*
    let filename = args.filename; // "../puzzle1";
    let fh = File::open(filename).unwrap();
    let puzzle: Ksudoku = from_reader(fh).unwrap();
    println!("Puzzle: {:?}", puzzle);
    */

    let mut s = Sudoku::new();
    s.load_from(puzzle.as_str());
    s.display();
    s.display_possible();

    while s.solve() {
        println!("Try it again...");
        s.display();
        s.display_possible();
    }

    /*
    s.display();
    s.display_possible();
    */

    /*
    let mut g = Group::new();
    g.for_row(1, 1);
    print!("Row: ");
    println!("{:?}", g);
    println!("{:#?}", g);
    // g.display();
    print!("Col: ");
    g.for_column(1, 1);
    println!("{:?}", g);
    // g.display();
    println!("Blk testing output: ");

    for i in 0..SIZE {
        g.for_block(i, i);
        println!("({},{} {:#?})", i, i, g);
        // g.display();
    }
    */
}
